#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
using namespace std;
//#define int long long
using ll = long long;
#define sz(e) (int)e.size()
const ll inf = 8 * 1e18;
ll s;
int n, m;

inline vector<int> to_bin(int a, int b) {
    vector<int> d(b);
    for (int i = b - 1; i >= 0; --i) {
        d[i] = (a & 1);
        a = (a >> 1);
    }
    return d;
}

inline void get_true(int strochki, int num, int sznum, int num2, int sznum2) {
    vector<int> s1 = to_bin(num, sznum);
    for (int i = sznum2 - 1; i >= 0; --i) {
        s1.emplace_back(num2 & (1 << i));
    }
    int ans = 0;
    cout << "YES\n";
    for (int i = 0; i < n;++i) {
        if (!(strochki & (1 << (n - 1 - i)))) {
            ans++;
        }
    }
    for (int i = 0; i < sz(s1); ++i) {
        if (!s1[i]) ans++;
    }
    cout << ans << '\n';
    for (int i = 0; i < n; ++i) {
        if (!(strochki & (1 << (n - 1 - i)))) {
            cout << 1 << " " << i + 1 << '\n';
        }
    }
    for (int i = 0; i < sz(s1); ++i) {
        if (!s1[i]) {
            cout << 2 << " " << i + 1 << '\n';
        }
    }
    exit(0);
}

inline void solve(vector<ll> &p, int b1) {
    unordered_map<ll, int> mp;
    int s1 = m - m / 2;
    int s2 = m / 2;
    vector<ll> c1(s1), c2(s2);
    for (int i = 0; i < s1; ++i) {
        c1[i] = p[i];
    }
    for (int i = 0; i < s2; ++i) {
        c2[i] = p[s1 + i];
    }
    for (int i = 1; i < (1 << s1); ++i) {
        ll cnt = 0;
        for (int j = s1 - 1; j >= 0; --j) {
            if (i & (1 << j)) {
                cnt += c1[s1 - j - 1];
            }
        }
        if (mp[cnt]) continue;
        mp[cnt] = i;
    }
    for (int i = 0; i < (1 << s2); ++i) {
        ll cnt = 0;
        for (int j = s2 - 1; j >= 0; --j) {
            if (i & (1 << j)) {
                cnt += c2[s2 - j - 1];
            }
        }
        if (mp[s - cnt]) {
            get_true(b1, mp[s - cnt], s1, i, s2);
        } else if (cnt == s) {
            get_true(b1, 0, s1, i, s2);
        }
    }
}

signed main() {
    iostream::ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> m;
    vector<vector<int>> v(n, vector<int>(m, 0));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) cin >> v[i][j];
    }
    cin >> s;
    for (int i = 1; i < (1 << n); ++i) {
        vector<ll> p(m);
        for (int j = 0; j < n; ++j) {
            if (!(i & (1 << (n - j - 1)))) continue;
            for (int z = 0; z < m; ++z) {
                p[z] += v[j][z];
            }
        }
        solve(p, i);
    }
    cout << "NO";
    return 0;
}
