#include <bits/stdc++.h>
//#pragma GCC optimize("Ofast")
using namespace std;
//#define int long long
using ll = long long;
#define sz(e) (int)e.size()
const ll inf = 8 * 1e18;
int n, k, t;
vector<vector<int>> g;
vector<int> d;

void dfs(int v, int p) {
    if (v != p) d[v] = d[p] + 1;
    for (auto a : g[v]) {
        if (a == p) continue;
        dfs(a, v);
    }
}

void solve(int p) {
    int l = 0, r = 10;
    d[p] = 0;
    dfs(p, p);
    int ans = 1e9;
    for (int m = 1; m <= n; ++m) {
        int cnt = 0;
        for (int j = 0; j < n; ++j) {
            if (j == p) continue;
            else if (d[j] == m + 1) {
                cnt++;
            } else if (d[j] > m + 1 && (d[j] - m - 1) % m == 0) {
                cnt++;
            }
        }
        if (cnt <= k) {
            ans = m;
            break;
        }
    }
    cout << ans << '\n';
}

signed main() {
    iostream::ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> k >> t;
    g.resize(n);
    d.resize(n);
    for (int i = 0; i < n - 1; ++i) {
        int a, b;
        cin >> a >> b;
        a--, b--;
        g[a].emplace_back(b);
        g[b].emplace_back(a);
    }
    if (t == 1) {
        for (int i = 0; i < n; ++i) {
            solve(i);
        }
    } else {
        solve(0);
    }

    return 0;
}








